<?php

namespace Drupal\aegir_site_subscriptions\HostingServiceCalls;

use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Fetches the list of profiles via Aegir's Web service API.
 */
abstract class ListHostingServiceCall extends HostingServiceCall {

  /**
   * Factory method.
   *
   * @param \Symfony\Component\DependencyInjection\ContainerInterface $container
   *   The service container this instance should use.
   *
   * @return \Drupal\aegir_site_subscriptions\HostingServiceCalls\ListHostingServiceCall
   *
   * @see ContainerInjectionInterface::create()
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('logger.factory')->get('aegir_site_subscriptions'),
      $container->get('http_client'),
      $container->get('config.factory')->get('aegir_site_subscriptions.settings'),
      $container->get('request_stack')->getCurrentRequest(),
      $container->get('module_handler'),
      $container->get('messenger')
    );
  }

}
